import { CardShape } from "./shapes";
import { CardMove } from "./moves";
declare type CardProps = {
    value: number;
    shape: CardShape;
    move?: CardMove;
    image?: string;
    iNeed?: CardShape;
};
/**
 * Generate a new Card, which may be of any shape and value
 */
export declare class Card {
    value: number;
    shape: CardShape;
    move: CardMove;
    image?: string;
    iNeed?: CardShape;
    constructor(props: CardProps);
    matches: (card: Card) => boolean;
    render: () => string;
    reset: () => void;
    get score(): number;
}
export default Card;
export declare const GetTriangle: (props: Omit<CardProps, "shape">) => Card;
export declare const GetCircle: (props: Omit<CardProps, "shape">) => Card;
export declare const GetSquare: (props: Omit<CardProps, "shape">) => Card;
export declare const GetStar: (props: Omit<CardProps, "shape">) => Card;
export declare const GetCross: (props: Omit<CardProps, "shape">) => Card;
export declare const GetWhot: (props: Omit<CardProps, "shape">) => Card;
