"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GetWhot = exports.GetCross = exports.GetStar = exports.GetSquare = exports.GetCircle = exports.GetTriangle = exports.Card = void 0;
var shapes_1 = require("./shapes");
var moves_1 = require("./moves");
/**
 * Generate a new Card, which may be of any shape and value
 */
var Card = /** @class */ (function () {
    function Card(props) {
        var _this = this;
        this.matches = function (card) {
            return (card.shape === _this.shape ||
                card.value === _this.value ||
                (_this.shape === shapes_1.default.Whot && _this.iNeed && _this.iNeed === card.shape) ||
                card.shape === shapes_1.default.Whot);
        };
        this.render = function () { return "".concat(_this.shape, " (").concat(_this.value, ")"); };
        this.reset = function () {
            _this.iNeed = undefined;
        };
        this.value = props.value;
        this.shape = props.shape;
        this.move = props.move || (0, moves_1.GetMove)(props.value);
        this.image = props.image;
        this.iNeed = props.iNeed;
    }
    Object.defineProperty(Card.prototype, "score", {
        get: function () {
            if (this.shape === shapes_1.default.Star)
                return this.value * 2;
            else
                return this.value;
        },
        enumerable: false,
        configurable: true
    });
    return Card;
}());
exports.Card = Card;
exports.default = Card;
var GetTriangle = function (props) {
    return new Card(__assign(__assign({}, props), { shape: shapes_1.default.Triangle }));
};
exports.GetTriangle = GetTriangle;
var GetCircle = function (props) {
    return new Card(__assign(__assign({}, props), { shape: shapes_1.default.Circle }));
};
exports.GetCircle = GetCircle;
var GetSquare = function (props) {
    return new Card(__assign(__assign({}, props), { shape: shapes_1.default.Square }));
};
exports.GetSquare = GetSquare;
var GetStar = function (props) {
    return new Card(__assign(__assign({}, props), { shape: shapes_1.default.Star }));
};
exports.GetStar = GetStar;
var GetCross = function (props) {
    return new Card(__assign(__assign({}, props), { shape: shapes_1.default.Cross }));
};
exports.GetCross = GetCross;
var GetWhot = function (props) {
    return new Card(__assign(__assign({}, props), { shape: shapes_1.default.Whot }));
};
exports.GetWhot = GetWhot;
//# sourceMappingURL=card.js.map