"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Deck = void 0;
var logger_1 = require("./logger");
var events_1 = require("./events");
var card_1 = require("./card");
var logger = (0, logger_1.default)("deck.js");
var circles = [1, 2, 3, 4, 5, 7, 8, 10, 11, 12, 13, 14];
var triangles = [1, 2, 3, 4, 5, 7, 8, 10, 11, 12, 13, 14];
var crosses = [1, 2, 3, 5, 7, 10, 11, 13, 14];
var squares = [1, 2, 3, 5, 7, 10, 11, 13, 14];
var stars = [1, 2, 3, 4, 5, 7, 8];
var whots = [20, 20, 20, 20, 20];
/**
 * @event deck:create
 * @event deck:shuffle
 */
var Deck = /** @class */ (function () {
    function Deck(props) {
        this.cards = [];
        if (!props.emitter) {
            logger.warn("props.emitter not defined");
            this.emitter = new events_1.EventEmitter();
        }
        else {
            this.emitter = props.emitter;
        }
        this.shuffle();
    }
    Deck.prototype.shuffle = function () {
        var _this = this;
        this.cards = __spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray(__spreadArray([], circles.map(function (value) { return (0, card_1.GetCircle)({ value: value }); }), true), triangles.map(function (value) { return (0, card_1.GetTriangle)({ value: value }); }), true), crosses.map(function (value) { return (0, card_1.GetCross)({ value: value }); }), true), squares.map(function (value) { return (0, card_1.GetSquare)({ value: value }); }), true), stars.map(function (value) { return (0, card_1.GetStar)({ value: value }); }), true), whots.map(function (value) { return (0, card_1.GetWhot)({ value: value }); }), true);
        this.cards = this.cards
            .map(function (card, index) { return index; })
            .sort(function (a, b) { return Math.random() - 0.5; })
            .map(function (index) { return _this.cards[index]; });
        if (this.emitter && typeof this.emitter.emit === "function") {
            this.emitter.emit("deck:shuffle", this.cards);
        }
        logger.warn("cards shuffled");
        return this.cards;
    };
    return Deck;
}());
exports.Deck = Deck;
exports.default = Deck;
//# sourceMappingURL=deck.js.map