/// <reference types="node" />
import { EventEmitter } from "events";
export declare const emitter: EventEmitter;
export default emitter;
export { EventEmitter };
export declare const raiseEvent: (name: string, ...args: any[]) => void;
declare type EventListener = (...dataArgs: any[]) => any;
declare type Emitter<TOriginal> = Partial<{
    events: Record<string, EventListener[]>;
    on: (event: string, listener: EventListener) => TOriginal & Emitter<TOriginal>;
    removeListener: (event: string, listener: EventListener) => TOriginal & Emitter<TOriginal>;
    emit: (event: string, ...dataArgs: any[]) => TOriginal & Emitter<TOriginal>;
    once: (event: string, listener: EventListener) => TOriginal & Emitter<TOriginal>;
}>;
declare type EventifiedObject<TOriginal extends Record<string, any>> = TOriginal & Emitter<TOriginal>;
export declare const eventify: <TSelf extends Record<string, any>>(self: EventifiedObject<TSelf>) => EventifiedObject<TSelf>;
