"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.eventify = exports.raiseEvent = exports.EventEmitter = exports.emitter = void 0;
var events_1 = require("events");
Object.defineProperty(exports, "EventEmitter", { enumerable: true, get: function () { return events_1.EventEmitter; } });
exports.emitter = new events_1.EventEmitter();
exports.default = exports.emitter;
var raiseEvent = function (name) {
    var args = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        args[_i - 1] = arguments[_i];
    }
    exports.emitter.emit.apply(exports.emitter, __spreadArray([name], args, false));
};
exports.raiseEvent = raiseEvent;
var eventify = function (self) {
    self.events = {};
    self.on = function (event, listener) {
        var _a, _b, _c;
        if (self.events && !Array.isArray((_a = self.events) === null || _a === void 0 ? void 0 : _a[event])) {
            self.events[event] = [];
        }
        (_c = (_b = self.events) === null || _b === void 0 ? void 0 : _b[event]) === null || _c === void 0 ? void 0 : _c.push(listener);
        return self;
    };
    self.removeListener = function (event, listener) {
        var _a;
        var idx;
        if (self.events && Array.isArray((_a = self.events) === null || _a === void 0 ? void 0 : _a[event])) {
            idx = self.events[event].indexOf(listener);
            if (idx > -1) {
                self.events[event].splice(idx, 1);
            }
        }
        return self;
    };
    self.emit = function (event, data) {
        var _a;
        var i, listeners, length;
        if (self.events && Array.isArray((_a = self.events) === null || _a === void 0 ? void 0 : _a[event])) {
            listeners = self.events[event].slice();
            length = listeners.length;
            for (i = 0; i < length; i++) {
                listeners[i].apply(self, [data]);
            }
        }
        return self;
    };
    self.once = function (event, listener) {
        if (typeof self.on === "function") {
            self.on(event, function g(data) {
                if (typeof self.removeListener === "function") {
                    self.removeListener(event, g);
                }
                listener.apply(self, [data]);
            });
        }
        return self;
    };
    return self;
};
exports.eventify = eventify;
//# sourceMappingURL=index.js.map