/// <reference types="node" />
import Card from "./card";
import Market from "./market";
import Pile from "./pile";
import Player from "./player";
import Turn from "./turn";
import { EventEmitter } from "./events";
declare type GameProps = {
    noOfDecks: number;
    noOfPlayers: number;
    firstCard?: Card;
};
export declare class Game {
    noOfDecks: number;
    noOfPlayers: number;
    pile: Pile;
    market: Market;
    turn: Turn;
    players: Player[];
    emitter: EventEmitter;
    constructor(props: GameProps);
    initPlayers(): void;
    /**
     * distribute 4 cards to each player one by one
     */
    deal: () => void;
    playFirstCard: (firstCard?: Card) => Card;
}
export default Game;
