"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createLogger = void 0;
var colors_1 = require("./colors");
var createLogger = function (name) {
    return {
        log: function (message) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return console.log.apply(console, __spreadArray(__spreadArray(["".concat(name, ":"), colors_1.default.FgCyan, message], args, false), [colors_1.default.Reset], false));
        },
        warn: function (message) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return console.warn.apply(console, __spreadArray(__spreadArray(["".concat(name, " (warn):"), colors_1.default.FgYellow,
                message], args, false), [colors_1.default.Reset], false));
        },
        error: function (message) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return console.error.apply(console, __spreadArray(__spreadArray(["".concat(name, " (error):"), colors_1.default.FgRed,
                message], args, false), [colors_1.default.Reset], false));
        },
    };
};
exports.createLogger = createLogger;
exports.default = exports.createLogger;
//# sourceMappingURL=index.js.map