/// <reference types="node" />
import { EventEmitter } from "events";
import Pile from "./pile";
import Card from "./card";
declare type MarketProps = {
    noOfDecks?: number;
    emitter: EventEmitter;
    pile: () => Pile;
};
/**
 * @event market:create
 * @event market:pick
 */
export declare class Market {
    noOfDecks: number;
    emitter: EventEmitter;
    pile: () => Pile;
    private cards;
    constructor(props: MarketProps);
    shuffle: () => void;
    pick: (no?: number) => Card[];
    count: () => number;
}
export default Market;
