/// <reference types="node" />
import { EventEmitter } from "events";
import Card from "./card";
declare type PileProps = {
    emitter: EventEmitter;
};
/**
 * @event pile:push
 * @event pile:reset
 */
export declare class Pile {
    emitter: EventEmitter;
    cards: Card[];
    noOfPlays: number;
    constructor(props: PileProps);
    top: () => Card;
    firstCardIsWhot: () => boolean;
    push: (_cards_: Card[]) => void;
    reset: () => Card[];
}
export default Pile;
